<template>
  <form class="item-form" @submit.prevent="onFormSubmit">
    <div class="item-form__controls-wrapper">
      <div class="item-form__field">
        <input
          v-model="form.name"
          required
          placeholder="Product name"
          class="input"
        />
      </div>
      <div class="item-form__field">
        <input
          v-model="form.price"
          type="number"
          required
          placeholder="Price"
          class="input"
          :min="0"
        />
      </div>
      <div class="item-form__field">
        <input
          v-model="form.quantity"
          type="number"
          required
          placeholder="Quantity"
          class="input"
          :min="0"
        />
      </div>
    </div>
    <button type="submit" class="btn btn--success">Submit</button>
  </form>
</template>

<script lang="ts">
import { Vue, Component } from "vue-property-decorator";
import { invoice_new_item } from "@/store/storeTypes";

const default_form_state: invoice_new_item = {
  name: "",
  price: "",
  quantity: "",
};

@Component
export default class NewItem extends Vue {
  form = { ...default_form_state };

  async onFormSubmit() {
    await this.$store.dispatch("addTableItem", { ...this.form });
    this.form = { ...default_form_state };
  }
}
</script>

<style lang="scss" scoped>
.item-form {
  display: grid;
  grid-template-columns: 4fr 1fr;
  grid-gap: 2rem;
  &__controls-wrapper {
    display: grid;
    grid-gap: 2rem;
    grid-template-columns: 3fr 1fr 1fr;
  }
}
</style>
